// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__D745D35D_8415_4821_9789_CD847CAF9B48__INCLUDED_)
#define AFX_STDAFX_H__D745D35D_8415_4821_9789_CD847CAF9B48__INCLUDED_

#ifdef _WIN32

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define EXPORT				__declspec(dllexport)
#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#define _WIN32_WINNT 0x0400
#define WINVER 0x0400
#include <windows.h>
#include <windowsx.h>			// Button_* etc
#include <shlwapi.h>
#include <mmsystem.h>
#include <commctrl.h>
#include <ShellAPI.h>
#include <winnt.h>			// For 32x32To64 multiplies

#include <process.h>

#include <d3d8.h>
#include <d3dx8.h>
#include <d3d8types.h>
#include <D3dx8math.h>
#else // _WIN32
#include "winlnxdefs.h"
#include "daedalus_math.h"
#include "D3DXCOLOR.h"
#endif // _WIN32

#include <stdio.h>
#include <math.h>			// For sqrt()
#include <iostream>
#include <fstream>
#include <istream>
#include "xmmintrin.h"


#include <vector>

// TODO: reference additional headers your program requires here
#ifndef _DEBUG
#define DAEDALUS_RELEASE_BUILD
#endif

#ifndef SAFE_DELETE
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#endif

#ifndef SAFE_DELETEARRAY
#define SAFE_DELETEARRAY(p)  { if(p) { delete [](p);     (p)=NULL; } }
#endif

#define ARRAYSIZE(arr)   (sizeof(arr) / sizeof(arr[0]))

#define DAEDLAUS_VERSION_NO		0x008b
#define DAEDALUS_VERSION		"0.08b"

#ifndef SAFE_CHECK
# define SAFE_CHECK(a)	if( (a) == NULL ) {ErrorMsg("Creater out of memory"); throw new std::exception();}
#endif

#ifndef SAFE_RELEASE
//#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }
#define SAFE_RELEASE(p) SAFE_DELETE(p)
#endif

#include "ultra_types.h"
#include "typedefs.h"
#include "gfx.h"
#include "DaedalusGraphics.h"
#include "Config.h"
#ifdef _WIN32
#include "resource.h"
#endif
#include "Debugger.h"
#include "RDP_S2DEX.h"
#include "DLParser.h"
#include "ultra_gbi.h"
#include "ultra_sptask.h"

#include "TextureCache.h"
#include "ConvertImage.h"
#include "Texture.h"
#ifdef _WIN32
#include "DirectXTexture.h"
#endif
#include "OGLTexture.h"

#include "Profiler.h"

#include "CombinerDefs.h"
#include "DecodedMux.h"
#include "OGLDecodedMux.h"
#ifdef _WIN32
#include "DirectXDecodedMux.h"
#endif

#include "blender.h"
#ifdef _WIN32
#include "DirectXBlender.h"
#endif


#include "Combiner.h"
#include "GeneralCombiner.h"
#ifdef _WIN32
#include "DirectXCombiner.h"
#endif
#include "CNvTNTCombiner.h"
#ifdef _WIN32
#include "CNvTNTDirectXCombiner.h"
#include "DirectXCombinerVariants.h"
#endif

#include "gl.h"
#include "glext.h"

#include "GraphicsContext.h"
#ifdef _WIN32
#include "DirectXGraphicsContext.h"
#endif
#include "DeviceBuilder.h"
#include "OGLGraphicsContext.h"

#include "OGLCombiner.h"
#include "OGLExtCombiner.h"
#include "OGLCombinerNV.h"
#include "OGLCombinerTNT2.h"

#include "TextureCache.h"
#include "DaedalusRenderBase.h"
#include "ExtendedRender.h"
#include "DaedalusRender.h"
#ifdef _WIN32
#include "D3DRender.h"
#endif
#include "OGLRender.h"
#include "OGLExtRender.h"

#ifdef _WIN32
#include "resource.h"
#endif

#include "daedalus_crc.h"

#include "ROM.h"
#include "RDP.h"
#include "IColor.h"

#include "ultra_mbi.h"
#include "CSortedList.h"
#include "CritSect.h"
#include "Timing.h"

extern WindowSettingStruct windowSetting;

extern BOOL g_bCRCCheck;			// Apply a crc-esque check to each texture each frame


void __cdecl MsgInfo (char * Message, ...);
void __cdecl ErrorMsg (char * Message, ...);

#define MI_INTR_DP          0x00000020  

extern DWORD g_dwRamSize;
extern DWORD * g_pu32RamBase;
extern signed char* g_ps8RamBase;

extern unsigned char *g_pu8RamBase;
extern unsigned char * g_pu8SpMemBase;
extern GFX_INFO g_GraphicsInfo;


//#define ENABLE_PROFILER

#ifdef ENABLE_PROFILER
#define StartProfiler(item)	CProfiler::Get()->StartTiming(item)
#define StopProfiler(item)	CProfiler::Get()->StopTiming(item)
#else
#define StartProfiler(item)
#define StopProfiler(item)
#endif

//#include "ResourceString.h"		// Useful everywhere
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__D745D35D_8415_4821_9789_CD847CAF9B48__INCLUDED_)
