/**
 * Mupen64 - winlnxdefs.h
 * Copyright (C) 2002 Hacktarux
 *
 * Mupen64 homepage: http://mupen64.emulation64.com
 * email address: hacktarux@yahoo.fr
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef WINLNXDEFS_H
#define WINLNXDEFS_H

typedef unsigned int BOOL;
typedef unsigned long DWORD, *LPDWORD;
typedef unsigned short WORD, SHORT;
typedef unsigned char BYTE, CHAR, TCHAR, *LPBYTE;
typedef unsigned int UINT, uint, ULONG;
typedef long LONG;
typedef void VOID;
typedef long long LONGLONG;
typedef float FLOAT;

#define __int16 short
#define __int32 long
#define __int64 long long

typedef void*  HINSTANCE;
typedef void*  HWND;
typedef int WPARAM;
typedef int LPARAM;
typedef void* LPVOID;
typedef bool HRESULT;
typedef char* LPCTSTR;
typedef char* LPCSTR;
typedef void* HMENU;
typedef void* WINDOWPLACEMENT;
typedef void* DEVMODEA;
typedef void* HDC;
typedef void* HGLRC;

typedef struct
{ 
   int top;
   int bottom;
   int right;
   int left;
} RECT;

#define __declspec(dllexport)
#define _cdecl
#define __cdecl
#define WINAPI

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define S_OK 1

#define MAX_PATH PATH_MAX

typedef DWORD D3DCOLOR;
typedef int D3DFORMAT;
typedef void* IDirect3DSurface8;
typedef void* LPDIRECT3DSURFACE8;

typedef enum _D3DBLEND 
{
   
         D3DBLEND_ZERO               = 1,
         D3DBLEND_ONE                = 2,
         D3DBLEND_SRCCOLOR           = 3,
         D3DBLEND_INVSRCCOLOR        = 4,
         D3DBLEND_SRCALPHA           = 5,
         D3DBLEND_INVSRCALPHA        = 6,
         D3DBLEND_DESTALPHA          = 7,
         D3DBLEND_INVDESTALPHA       = 8,
         D3DBLEND_DESTCOLOR          = 9,
         D3DBLEND_INVDESTCOLOR       = 10,
         D3DBLEND_SRCALPHASAT        = 11,
         D3DBLEND_BOTHSRCALPHA       = 12,
         D3DBLEND_BOTHINVSRCALPHA    = 13,
         D3DBLEND_FORCE_DWORD        = 0x7fffffff, /* force 32-bit size enum */
} D3DBLEND;

#define D3DFMT_A8R8G8B8 0

//#define D3DCOLOR_RGBA(r,g,b,a) (((r&0xFF)<<24) | ((g&0xFF)<<16) | ((b&0xFF)<<8) | ((a&0xFF)<<0))
#define D3DCOLOR_RGBA(r,g,b,a) (((r&0xFF)<<16) | ((g&0xFF)<<8) | ((b&0xFF)<<0) | ((a&0xFF)<<24))
#define CONST const

#define SUCCEEDED(a) a
#define _ASSERT assert
#define _ASSERTE assert

#endif
